]> git.phdru.name Git - dotfiles.git/blob - .shellrc
Feat(recode-filenames-recursive): Allow to omit parameters
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60 if test -n "$BASH_VERSION"; then
61    [ "`type -t ls`" = alias ] && unalias ls
62    [ "`type -t ll`" = alias ] && unalias ll
63    [ "`type -t mc`" = alias ] && unalias mc
64
65    back() { cd - "$@"; }
66    functions() { typeset -f "$@"; }
67    j() { jobs; }
68
69    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
70       if [ -d /usr/share/bash-completion -a -r /usr/share/bash-completion/bash_completion ]; then
71          _BASH_COMPLETIONS_DIR=/usr/share/bash-completion/completions
72          . /usr/share/bash-completion/bash_completion
73       elif [ -r /etc/bash_completion ]; then
74          _BASH_COMPLETIONS_DIR=/etc/bash_completion.d
75          . /etc/bash_completion
76       elif [ -d /etc/bash_completion.d ]; then
77          _BASH_COMPLETIONS_DIR=/etc/bash_completion.d
78          for _compf in /etc/bash_completion.d/*; do
79             . $_compf
80          done
81       elif [ -d /usr/local/etc/bash_completion.d ]; then
82          _BASH_COMPLETIONS_DIR=/usr/local/etc/bash_completion.d
83          for _compf in /usr/local/etc/bash_completion.d/*; do
84             . $_compf
85          done
86       else
87          echo "Unknown OS type, cannot source bash_completion" >&2
88       fi
89    fi
90
91    has_completion() {
92       [ -n "$_BASH_COMPLETIONS_DIR" -a -d "$_BASH_COMPLETIONS_DIR" -a -r "$_BASH_COMPLETIONS_DIR/$1" ] ||
93       complete -p $1 >/dev/null 2>&1
94    }
95
96    for cmd in builtin cgmem_nice command dbus-launch exec \
97          killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg \
98          run-hosts su sudo time whence whereis which xargs; do
99       ! has_completion $cmd && complete -o default -A command $cmd
100    done
101
102    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 \
103          ssh2 s2 socat telnet t tt \
104          tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
105          whois wd wget wget-download wget-m wget-wrapper ww; do
106       ! has_completion $cmd && complete -A hostname $cmd
107    done
108
109    for cmd in distribute ftp lftp r rsync \
110          s scp ssh smbclient tcpdump tshark wireshark; do
111       ! has_completion $cmd && complete -o default -A hostname $cmd
112    done
113
114    for cmd in bg fg jobs; do
115       ! has_completion $cmd && complete -A job $cmd
116    done
117
118    complete -A job j wait
119
120    for cmd in unset; do
121       ! has_completion $cmd && complete -A function -A variable $cmd
122    done
123
124    if [ -d "$HOME"/.bash_completion.d ]; then
125       for _compf in "$HOME"/.bash_completion.d/*; do
126          . $_compf
127       done
128    fi
129
130    delegate_completion() {
131       local prog programs
132       prog=$1
133       ! has_completion $prog && return
134       shift
135       programs="$@"
136       eval "_${prog}_completion_loader() {
137          _completion_loader $prog
138          complete -o nospace -F _$prog $programs
139          unset _${prog}_completion_loader
140          return 124
141       }"
142       complete -F _${prog}_completion_loader $programs
143    }
144
145    delegate_completion make m
146    delegate_completion ping p
147    delegate_completion rsync r rsync_cgmn rsync_cgmn_recode
148    delegate_completion ssh s
149    delegate_completion wget wget-m wget-wrapper ww
150
151    unset _BASH_COMPLETIONS_DIR has_completion delegate_completion
152
153    if [ -d "$HOME/lib/config" ]; then
154       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
155    fi
156    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
157
158    if [ "`type -t short_curdir`" != function -a \
159          -r "$HOME"/admin/prog/bash_prompt ]; then
160       . "$HOME"/admin/prog/bash_prompt
161    fi
162
163    #if type -p pip >/dev/null 2>&1; then
164    #   eval "`pip completion --bash`"
165    #   rm -rf /tmp/pip_build_"$USER"
166    #fi
167
168    #if which pyenv >/dev/null 2>&1; then
169    #   eval "`pyenv init -`"
170    #   eval "`pyenv virtualenv-init -`"
171    #fi
172
173    . virtualenvwrapper_lazy.sh 2>/dev/null
174
175    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
176       . "$VIRTUAL_ENV/bin/activate"
177    fi
178
179    # Clean up python virtual environment on exit
180    # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
181
182    trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
183
184 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
185    back() { cd - "$@"; }
186    j() { jobs; }
187 fi
188
189 PS1="$OPS1"
190
191 # clear screen and history, logout
192 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
193
194
195 if test -x /usr/bin/git >/dev/null 2>&1; then
196    # chdir to a directory
197    cdgitpath() {
198       if [ $# -ne 1 ]; then
199          echo "Usage: cdgitpath path_key" >&2
200          return 1
201       fi
202
203       path_key="$1"
204       if [ -z "$path_key" ]; then
205          echo "Usage: cdgitpath path_key" >&2
206          return 1
207       fi
208
209       path_url="`git config --get --path $path_key`"
210       if echo "$path_url" | grep -q '^file:/'; then
211          path_url="`echo \"$path_url\" | sed 's@^file:/\+@/@'`"
212       fi
213       cd "$path_url"
214    }
215
216    # chdir to a remote's directory (if the remote is on the local FS)
217    cdremote() {
218       if [ $# -gt 1 ]; then
219          echo "Usage: cdremote [remote_name]" >&2
220          return 1
221       fi
222
223       if [ -z "$1" ]; then
224          branch="`git rev-parse --abbrev-ref HEAD`"
225          remote="`git config --get branch.$branch.remote`"
226       else
227          remote="$1"
228       fi
229
230       if [ -n "$remote" ] && git config --get remote.$remote.url |
231             grep -q '^\(file:/\|/\|\.\./\)'; then # (file:/ or / or ../ at the beginning)
232          cdgitpath remote.$remote.url
233       else
234
235          if [ -n "$1" ]; then
236             echo "Cannot find directory for remote $1" >&2
237             echo "Usage: cdremote [remote_name]" >&2
238             return 1
239          fi
240
241          if test -n "$BASH_VERSION"; then
242             _list_remotes '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
243             if [ ${#GIT_REMOTES[*]} -eq 1 ]; then
244                remote=${GIT_REMOTES[0]}
245                unset GIT_REMOTES
246                cdgitpath remote.$remote.url
247             else
248                unset GIT_REMOTES
249                echo "Cannot find directory for any remote" >&2
250                echo "Usage: cdremote [remote_name]" >&2
251                return 1
252             fi
253          else
254             echo "Cannot find directory for remote $1" >&2
255             echo "Usage: cdremote [remote_name]" >&2
256             return 1
257          fi
258       fi
259    }
260
261    if test -n "$BASH_VERSION"; then
262       # completion for aliases in global .gitconfig
263
264       # fixup rbi rbia rbiap rbip - do refs name completion
265       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
266       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
267       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
268       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
269       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
270       #
271       # push-to-all-remotes - do branch name completion
272       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
273
274       _cdgitpath_complete() {
275          local cur="${COMP_WORDS[COMP_CWORD]}"
276          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
277       }
278
279       _git_open() {
280          _cdgitpath_complete
281       }
282
283       complete -F _cdgitpath_complete cdgitpath git-open
284
285       # list remotes with URLs matching a regexp
286       _list_remotes() {
287          if [ $# -ne 1 ]; then
288             echo "Usage: _list_remotes remote_regexp" >&2
289             return 1
290          fi
291          declare -ag GIT_REMOTES=()
292          local remote
293          for remote in `git remote`; do
294             if git config --get remote.$remote.url | grep -q "$1"; then
295                GIT_REMOTES+=($remote)
296             fi
297          done
298       }
299
300       # completion for cdremote and git-open-remote - list remotes with a pattern
301       _list_remotes_completion() {
302          local cur="${COMP_WORDS[COMP_CWORD]}"
303          _list_remotes "$1"
304          COMPREPLY=(`compgen -W "${GIT_REMOTES[*]}" -- "$cur"`)
305          unset GIT_REMOTES
306       }
307
308       # completion for cdremote - list remotes with directories as URLs
309       _cdremote_complete() {
310          _list_remotes_completion '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
311          if [ ${#COMPREPLY[*]} -eq 0 ]; then
312             _list_remotes_completion .
313          fi
314       }
315
316       complete -F _cdremote_complete cdremote
317
318       # completion for git-open-remote - list remotes with http(s) URLs
319       _git_open_remote() {
320          _list_remotes_completion '^http\(s\)\?://'
321          if [ ${#COMPREPLY[*]} -eq 0 ]; then
322             _list_remotes_completion .
323          fi
324       }
325
326       complete -F _git_open_remote git-open-remote
327    fi
328 fi
329
330
331 include() {
332    cfg="$1"
333    shift
334    if [ -f "./$cfg" -a -r "./$cfg" ]; then
335       echo "Reading config file \`$cfg'" 1>&2
336       . "./$cfg" "$@"
337    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
338       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
339       . "$HOME/lib/config/$cfg" "$@"
340    else
341       echo "Cannot find config file \`$cfg'" 1>&2
342    fi
343 }
344
345
346 mc() {
347    if test -n "$BASH_VERSION"; then
348       MC_SAVE_OPS1="$OPS1"
349       if [ "`type -t short_curdir`" = function ]; then
350          OPS1="\`cgmem_which_prompt\`\u@\${HOSTNAME::5}:\`short_curdir\`"
351          if test -x /usr/bin/git >/dev/null 2>&1; then
352             if [ "`type -t __git_ps1`" = function ]; then
353                OPS1+="\$(__git_ps1)"
354             else
355                OPS1+="\$(prompt_git)"
356             fi
357          fi
358          OPS1+=" \$SHLVL\\$ "
359       else
360          OPS1="\u@\h:\W \$SHLVL\\$ "
361       fi
362    fi
363
364    if [ -n "$SLOWTERM" ]; then
365       MC_SLOW="--slow"
366    fi
367
368    case "$TERM" in
369       screen*) # screen, screen.rxvt
370          MC_XTERM="-x"
371       ;;
372    esac
373
374    #TMPDIR="$HOME"/tmp
375    #export TMPDIR
376
377    MC_FOUND=NO
378
379    for wrapper in \
380          /usr/local/share/mc/bin/mc-wrapper.sh \
381          /usr/local/libexec/mc/mc-wrapper.sh \
382          /usr/share/mc/bin/mc-wrapper.sh; do
383       if [ -r $wrapper ]; then
384          . $wrapper $MC_SLOW $MC_XTERM "$@"
385          rc=$?
386          MC_FOUND=YES
387          break
388       fi
389    done
390
391    if [ $MC_FOUND = NO ]; then
392       for mc in /usr/local/bin/mc /usr/bin/mc; do
393          if [ -x $mc ]; then
394             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
395             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
396                MC_TMP_DIR="${TMPDIR-/tmp}"
397             fi
398             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
399             mc_type="`mc_type.py $mc`"
400             if [ "$mc_type" = old ]; then
401                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
402             elif [ "$mc_type" = new ]; then
403                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
404             else
405                continue
406             fi
407             rc=$?
408             MC_FOUND=YES
409             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
410             break
411          fi
412       done
413    fi
414
415    if [ $MC_FOUND = NO ]; then
416       echo "Cannot find mc-wrapper.sh or mc" >&2
417       rc=1
418    fi
419
420    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
421    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SLOW MC_TMP_DIR MC_XTERM
422
423    return $rc
424 }
425
426
427 mkcd() {
428    if [ $# -ne 1 ]; then
429       echo "Usage: mkcd directory_name" >&2
430    elif [ -d "$1" ]; then
431       cd "$1"
432    elif [ -e "$1" ]; then
433       echo "Error: $1 is a file" >&2
434    else
435       mkdir -p "$1" && cd "$1"
436    fi
437 }
438
439
440 if which tmux >/dev/null 2>&1; then
441    tmux() {
442       case "$TERM" in
443          rxvt)
444             TERM=rxvt-unicode command tmux "$@"
445          ;;
446
447          *)
448             command tmux "$@"
449          ;;
450       esac
451    }
452 fi
453
454
455 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
456    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
457 fi
458
459 x() { exit; }